/*
  COnfigurator for Gnome (COG)
  Copyright (C) 2002 Maxximum Software
   
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "gconf-convenience.h"

const gchar *gconf_entry_get_short_desc (GConfEntry *entry, GConfClient *client)
{
  GConfSchema *schema;
  GConfEntry *schema_entry;
  
  schema_entry = gconf_client_get_entry (client, gconf_entry_get_schema_name(entry), NULL, TRUE, NULL);
  schema = gconf_value_get_schema (gconf_entry_get_value (schema_entry)); /* FIXME - check for value == NULL */
  return gconf_schema_get_short_desc (schema);
}

const gchar *gconf_entry_get_long_desc (GConfEntry *entry, GConfClient *client)
{
  GConfSchema *schema;
  GConfEntry *schema_entry;
  
  schema_entry = gconf_client_get_entry (client, gconf_entry_get_schema_name(entry), NULL, TRUE, NULL);
  schema = gconf_value_get_schema (gconf_entry_get_value (schema_entry)); /* FIXME - check for value == NULL */
  return gconf_schema_get_long_desc (schema);
}

const gchar *gconf_key_get_short_desc (gchar *key)
{
  GConfClient *client;
  GConfEntry *entry;
  const gchar *return_val = NULL;

  /* Get the default client */
  client = gconf_client_get_default ();

  entry = gconf_client_get_entry (client, key, NULL, TRUE, NULL);
  if (entry != NULL)
    return_val = gconf_entry_get_short_desc (entry, client);
  
  g_object_unref (G_OBJECT (client));

  return return_val;
}

const gchar *gconf_key_get_long_desc (gchar *key)
{
  GConfClient *client;
  GConfEntry *entry;
  const gchar *return_val = NULL;

  /* Get the default client */
  client = gconf_client_get_default ();

  entry = gconf_client_get_entry (client, key, NULL, TRUE, NULL);
  if (entry != NULL)
    return_val = gconf_entry_get_long_desc (entry, client);
  
  g_object_unref (G_OBJECT (client));

  return return_val;
}

gboolean gconf_key_is_writable (gchar *key)
{
  GConfClient *client;
  GConfEntry *entry;
  gboolean return_val = FALSE;

  /* Get the default client */
  client = gconf_client_get_default ();

  entry = gconf_client_get_entry (client, key, NULL, TRUE, NULL);
  if (entry != NULL)
    return_val = gconf_client_key_is_writable (client, key, NULL);
  
  g_object_unref (G_OBJECT (client));

  return return_val;
}

gboolean gconf_key_exists (gchar *key)
{
  GConfClient *client;
  GConfEntry *entry;
  gboolean return_val = FALSE;

  /* Get the default client */
  client = gconf_client_get_default ();

  entry = gconf_client_get_entry (client, key, NULL, TRUE, NULL);
  if (gconf_entry_get_value (entry) != NULL)
    /*does the entry actually contain anything */
    return_val = TRUE;
  
  g_object_unref (G_OBJECT (client));

  return return_val;
}
