/*
  COnfigurator for Gnome (COG)
  Copyright (C) 2002 Maxximum Software
   
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <libxml/tree.h>
#include <libxml/parser.h>
#include <glib.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <string.h>
#include <gconf/gconf-client.h>

// An extended key (for practical purposes simple keys are modelled as extended keys with short_desc and long_desc == NULL)
typedef struct extended_key {
  gchar *gconf_key, *short_desc, *long_desc;
} extended_key, *extended_keyPtr;

// A single section
typedef struct section {
  gchar *title;
  GList *extended_keys;
} section, *sectionPtr;

// A pool of sections
typedef struct cogSections {
  GList *sections;
} cogSections, *cogSectionsPtr;


cogSectionsPtr parseSections (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
cogSectionsPtr sections_concat (cogSectionsPtr c1, cogSectionsPtr c2);
GtkWidget *create_main_window (cogSectionsPtr p);
void printSections (cogSectionsPtr p);
